# Updating an existing Expense

An expense that has already been created can be updated with an HTTP PUT request. Any required or optional
attribute, with the exception of workspace_id, can be changed in an update.


This endpoint returns structured Expense objects.
As with all Kantata OX API endpoints, the returned data will be referenced in sorted order in the results array
and will be indexed by ID in the expenses top-level JSON key.
Please see our Response Format section for more information.

Endpoint: PUT /expenses/{id}
Version: 1.0.0

## Path parameters:

  - `id` (integer, required)
    The ID of the Model.

## Query parameters:

  - `include` (string)
    Any of the below associations can be included in your request by providing the include param, e.g. include=association1,association2.
- active_submission (ExpenseReportSubmission)
- expense_category (ExpenseCategory) - The category associated with the expense.
- external_references (ExternalReference) - Includes references to external integrations for this object.
- receipt (Attachments::ReceiptAttachment) - Information about receipts associated with this expense, returned in the attachments top-level key.
- recent_submission (ExpenseReportSubmission) - The most recent expense report the expense was submitted in, including any rejected or cancelled reports.
- role (Role) - The role of the user.
- story (Story) - Linked task, returned in the stories top-level key.
- user (User) - The user who created the expense, returned in the users top-level key.
- vendor (Vendor) - The party to which the expense is payable.
- workspace (Workspace) - The project to which this expense belongs, returned in the workspaces top-level key.

  - `optional_fields` (array)
    Allows you to request one or more optional fields as an array.
    Enum: "user_can_edit"

## Request fields (application/json):

  - `expense` (object)

  - `expense.amount_in_cents` (integer, required)
    The amount of the expense, in cents. If 'foreign_exchange_amount' is specified, that overrides the 'amount_in_cents'.

  - `expense.workspace_id` (integer)
    The ID of the project in which the expense will be associated.

  - `expense.date` (string)
    The date of the expense in ISO8601 format. The date must be in [ISO 8601](https://www.w3.org/TR/NOTE-datetime) format.

  - `expense.expense_category_id` (integer)
    The ID of the category to which the expense will be associated.

  - `expense.category` (string)
    The category of the expense as a string.

  - `expense.foreign_exchange_amount` (object)
    If you have permission to convert expenses, this is the expense in foreign currency units.

  - `expense.foreign_exchange_amount.source_value` (string, required)
    The amount of the expense, in foreign currency units.

  - `expense.foreign_exchange_amount.source_currency` (string, required)
    The [ISO code](https://mavenlink.zendesk.com/hc/en-us/articles/360041576473-Supported-Currency-ISO-Codes) of the foreign currency in which the expense was incurred.

  - `expense.user_id` (integer)
    The internal ID of the user with whom the expense is associated. This parameter is ignored unless the
authorizing user has financial access in the project and is on the consultants team; or if they
are an Account Administrator that has proxy permissions through an account member with the necessary permissions.

  - `expense.notes` (string)
    Freeform text related to the expense.

  - `expense.billable` (boolean)
    A boolean that indicates whether or not this expense is billable.

  - `expense.receipt_id` (integer)
    The optional ID of an attached receipt for this expense.

  - `expense.story_id` (integer)
    The optional ID of a task in the project (this will be linked to this expense). Depending on the
project's settings, expenses can be associated with only expense budgets or only tasks.

  - `expense.expense_budget_id` (integer)
    The optional ID of an expense budget in the project (this will be linked to this expense). Depending
on the project's settings, expenses can be associated with only expense budgets or only tasks.

  - `expense.external_reference` (object)
    Typically populated programmatically by a third party system via an integration, this is an optional
object that holds data from an external system. It connects objects in an external system with objects in
Kantata OX (for example, to connect a Jira issue to a Kantata OX Project).

  - `expense.external_reference.service_name` (string, required)
    The provider name of the integration. If you are adding multiple external references to the same object, the service_name must be unique.

  - `expense.external_reference.service_model` (string, required)
    The object type of the external object this external reference belongs to.

  - `expense.external_reference.service_model_ref` (string, required)
    The object ID of the external object this external reference belongs to.

  - `expense.external_reference.status` (string)
    The status of the integration. Options are successful, pending,  or failed.

  - `expense.external_reference.external_message` (string)
    The message on the external object.

  - `expense.external_reference.external_link` (string)
    The link to the external object.

  - `expense.external_reference.external_status` (string)
    The status of the external object in the external system.

  - `expense.external_reference.locked` (boolean)
    Whether the subject is locked.

## Response 200 fields (application/json):

  - `count` (integer)

  - `meta` (object)

  - `meta.count` (integer)

  - `meta.page_count` (integer)

  - `meta.page_number` (integer)

  - `meta.page_size` (integer)

  - `results` (array)

  - `results.key` (string)

  - `results.id` (string)

  - `expenses` (object)

  - `external_references` (object)

  - `stories` (object)

  - `workspaces` (object)

  - `users` (object)

  - `attachments` (object)

  - `expense_report_submissions` (object)

  - `expense_categories` (object)

  - `roles` (object)

  - `vendors` (object)

## Response 400 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 401 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 403 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 404 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 422 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 503 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)


